function txtlen = showprog( isim, nsims, progstep, txtlen )

% This function nicely prints the loop progress with a percentage.
%
% NOTICE:
% -------
% Permission is hereby granted to use this code freely for academic
% purposes only, provided that the paper is duly cited as:
%
% Eisenstat, E., Chan, J. C. C. and R. W. Strachan (2015). "Stochastic Model
% Specification Search for Time-Varying Parameter VARs," Econometric
% Reviews, forthcoming.
%
% Any other use of this code, particularly for comercial purposes, is
% strictly prohibited without the prior written consent of the authors.
% Furthermore, this code comes without technical support of any kind.  It
% is expected to reproduce the results reported in the paper.  However,
% beware that the notation may not the match text.  Likewise, it is not
% gauranteed to work under different hardware and / or software settings,
% other than those used for its original design and implementation.
%
% Under no circumstances will the authors be held responsible for any use
% (or misuse) of this code in any way.  If you do not agree to the above,
% you do not have permission to use this code.

if mod( isim, floor( nsims / progstep ) ) == 0
    if ispc
        for cnt = 1:txtlen
            fprintf( '\b' );
        end
        txtlen = fprintf( '%d iterations completed (%3.1f%%)', isim, isim / nsims * 100 );
    else
        fprintf( '\r%d iterations completed (%3.1f%%)', isim, isim / nsims * 100 );
    end      
end
